git-bisect.sh: don't accidentally override existing branch "bisect"
[git/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
6ca8b977 3USAGE='[start|bad|good|skip|next|reset|visualize|replay|log|run]'
38a47fd6
CC
4LONG_USAGE='git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
5 reset bisect state and start bisection.
6git bisect bad [<rev>]
7 mark <rev> a known-bad revision.
8git bisect good [<rev>...]
9 mark <rev>... known-good revisions.
6ca8b977
CC
10git bisect skip [<rev>...]
11 mark <rev>... untestable revisions.
38a47fd6
CC
12git bisect next
13 find next bisection to test and check it out.
14git bisect reset [<branch>]
15 finish bisection search and go back to branch.
16git bisect visualize
17 show bisect status in gitk.
18git bisect replay <logfile>
19 replay bisection log.
20git bisect log
21 show bisect log.
22git bisect run <cmd>...
23 use <cmd>... to automatically bisect.'
d025524d 24
8f321a39 25OPTIONS_SPEC=
ae2b0f15 26. git-sh-setup
4c550686 27require_work_tree
8cc6a083 28
ce32660e
JS
29_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
30_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
31
e9a45d75 32sq() {
d9bffc08 33 @@PERL@@ -e '
e9a45d75
JH
34 for (@ARGV) {
35 s/'\''/'\'\\\\\'\''/g;
36 print " '\''$_'\''";
37 }
38 print "\n";
39 ' "$@"
40}
41
8cc6a083 42bisect_autostart() {
6459c7c6 43 test -f "$GIT_DIR/BISECT_NAMES" || {
8cc6a083
LT
44 echo >&2 'You need to start by "git bisect start"'
45 if test -t 0
46 then
47 echo >&2 -n 'Do you want me to do it for you [Y/n]? '
48 read yesno
49 case "$yesno" in
50 [Nn]*)
51 exit ;;
52 esac
53 bisect_start
54 else
55 exit 1
56 fi
57 }
58}
59
60bisect_start() {
8cc6a083
LT
61 #
62 # Verify HEAD. If we were bisecting before this, reset to the
63 # top-of-line master first!
64 #
48949a18 65 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
ce32660e
JS
66 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
67 die "Bad HEAD - I need a HEAD"
ee831f7d
GP
68 #
69 # Check that we either already have BISECT_START, or that the
70 # branches bisect, new-bisect don't exist, to not override them.
71 #
72 test -s "$GIT_DIR/BISECT_START" ||
73 if git show-ref --verify -q refs/heads/bisect ||
74 git show-ref --verify -q refs/heads/new-bisect; then
75 die 'The branches "bisect" and "new-bisect" must not exist.'
76 fi
d3e54c88 77 start_head=''
8cc6a083 78 case "$head" in
673e5838 79 refs/heads/bisect)
ee831f7d 80 branch=`cat "$GIT_DIR/BISECT_START"`
810255fd 81 git checkout $branch || exit
8cc6a083 82 ;;
ce32660e 83 refs/heads/*|$_x40)
b577bb92
CW
84 # This error message should only be triggered by cogito usage,
85 # and cogito users should understand it relates to cg-seek.
810255fd 86 [ -s "$GIT_DIR/head-name" ] && die "won't bisect on seeked tree"
d3e54c88 87 start_head="${head#refs/heads/}"
8cc6a083
LT
88 ;;
89 *)
8098a178 90 die "Bad HEAD - strange symbolic ref"
8cc6a083
LT
91 ;;
92 esac
93
94 #
95 # Get rid of any old bisect state
96 #
38a47fd6 97 bisect_clean_state
38a47fd6
CC
98
99 #
100 # Check for one bad and then some good revisions.
101 #
102 has_double_dash=0
103 for arg; do
104 case "$arg" in --) has_double_dash=1; break ;; esac
105 done
106 orig_args=$(sq "$@")
107 bad_seen=0
d3e54c88 108 eval=''
38a47fd6
CC
109 while [ $# -gt 0 ]; do
110 arg="$1"
111 case "$arg" in
112 --)
8fe26f44 113 shift
38a47fd6
CC
114 break
115 ;;
116 *)
8fe26f44 117 rev=$(git rev-parse --verify "$arg^{commit}" 2>/dev/null) || {
38a47fd6
CC
118 test $has_double_dash -eq 1 &&
119 die "'$arg' does not appear to be a valid revision"
120 break
121 }
737c74ee
CC
122 case $bad_seen in
123 0) state='bad' ; bad_seen=1 ;;
124 *) state='good' ;;
125 esac
d3e54c88 126 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
8fe26f44 127 shift
38a47fd6
CC
128 ;;
129 esac
8fe26f44 130 done
38a47fd6
CC
131
132 sq "$@" >"$GIT_DIR/BISECT_NAMES"
d3e54c88
CC
133 test -n "$start_head" && echo "$start_head" >"$GIT_DIR/BISECT_START"
134 eval "$eval"
b8652b4d 135 echo "git-bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG"
38a47fd6 136 bisect_auto_next
8cc6a083
LT
137}
138
55624f9a
CC
139bisect_write() {
140 state="$1"
141 rev="$2"
737c74ee 142 nolog="$3"
55624f9a
CC
143 case "$state" in
144 bad) tag="$state" ;;
145 good|skip) tag="$state"-"$rev" ;;
146 *) die "Bad bisect_write argument: $state" ;;
147 esac
3d7cd64c 148 git update-ref "refs/bisect/$tag" "$rev"
f454cdc4 149 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
737c74ee 150 test -z "$nolog" && echo "git-bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
55624f9a
CC
151}
152
155fc795 153bisect_state() {
8cc6a083 154 bisect_autostart
155fc795
CC
155 state=$1
156 case "$#,$state" in
157 0,*)
158 die "Please call 'bisect_state' with at least one argument." ;;
159 1,bad|1,good|1,skip)
160 rev=$(git rev-parse --verify HEAD) ||
161 die "Bad rev input: HEAD"
162 bisect_write "$state" "$rev" ;;
e3389075 163 2,bad|*,good|*,skip)
155fc795 164 shift
d3e54c88 165 eval=''
e3389075 166 for rev in "$@"
155fc795 167 do
a179a303 168 sha=$(git rev-parse --verify "$rev^{commit}") ||
e3389075 169 die "Bad rev input: $rev"
d3e54c88
CC
170 eval="$eval bisect_write '$state' '$sha'; "
171 done
172 eval "$eval" ;;
e3389075
CC
173 *,bad)
174 die "'git bisect bad' can take only one argument." ;;
cc9f24d0
JH
175 *)
176 usage ;;
8cc6a083 177 esac
97e1c51e
CC
178 bisect_auto_next
179}
180
8cc6a083 181bisect_next_check() {
0a5280a9
JH
182 missing_good= missing_bad=
183 git show-ref -q --verify refs/bisect/bad || missing_bad=t
184 test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
6fecf191 185
0a5280a9
JH
186 case "$missing_good,$missing_bad,$1" in
187 ,,*)
188 : have both good and bad - ok
189 ;;
190 *,)
191 # do not have both but not asked to fail - just report.
192 false
193 ;;
194 t,,good)
195 # have bad but not good. we could bisect although
196 # this is less optimum.
197 echo >&2 'Warning: bisecting only with a bad commit.'
198 if test -t 0
199 then
200 printf >&2 'Are you sure [Y/n]? '
201 case "$(read yesno)" in [Nn]*) exit 1 ;; esac
202 fi
203 : bisect without good...
204 ;;
8cc6a083 205 *)
0a5280a9 206 THEN=''
6459c7c6 207 test -f "$GIT_DIR/BISECT_NAMES" || {
0a5280a9
JH
208 echo >&2 'You need to start by "git bisect start".'
209 THEN='then '
210 }
211 echo >&2 'You '$THEN'need to give me at least one good' \
212 'and one bad revisions.'
213 echo >&2 '(You can use "git bisect bad" and' \
214 '"git bisect good" for that.)'
215 exit 1 ;;
8cc6a083
LT
216 esac
217}
218
219bisect_auto_next() {
434d036f 220 bisect_next_check && bisect_next || :
8cc6a083
LT
221}
222
97e1c51e
CC
223filter_skipped() {
224 _eval="$1"
225 _skip="$2"
226
227 if [ -z "$_skip" ]; then
228 eval $_eval
229 return
230 fi
231
232 # Let's parse the output of:
233 # "git rev-list --bisect-vars --bisect-all ..."
234 eval $_eval | while read hash line
235 do
236 case "$VARS,$FOUND,$TRIED,$hash" in
237 # We display some vars.
238 1,*,*,*) echo "$hash $line" ;;
239
240 # Split line.
241 ,*,*,---*) ;;
242
243 # We had nothing to search.
244 ,,,bisect_rev*)
245 echo "bisect_rev="
246 VARS=1
247 ;;
248
249 # We did not find a good bisect rev.
250 # This should happen only if the "bad"
251 # commit is also a "skip" commit.
252 ,,*,bisect_rev*)
253 echo "bisect_rev=$TRIED"
254 VARS=1
255 ;;
256
257 # We are searching.
258 ,,*,*)
259 TRIED="${TRIED:+$TRIED|}$hash"
260 case "$_skip" in
261 *$hash*) ;;
262 *)
263 echo "bisect_rev=$hash"
264 echo "bisect_tried=\"$TRIED\""
265 FOUND=1
266 ;;
267 esac
268 ;;
269
270 # We have already found a rev to be tested.
271 ,1,*,bisect_rev*) VARS=1 ;;
272 ,1,*,*) ;;
273
274 # ???
275 *) die "filter_skipped error " \
276 "VARS: '$VARS' " \
277 "FOUND: '$FOUND' " \
278 "TRIED: '$TRIED' " \
279 "hash: '$hash' " \
280 "line: '$line'"
281 ;;
282 esac
283 done
284}
285
286exit_if_skipped_commits () {
287 _tried=$1
288 if expr "$_tried" : ".*[|].*" > /dev/null ; then
289 echo "There are only 'skip'ped commit left to test."
290 echo "The first bad commit could be any of:"
e23cb8c0 291 echo "$_tried" | tr '[|]' '[\012]'
97e1c51e
CC
292 echo "We cannot bisect more!"
293 exit 2
294 fi
295}
296
8cc6a083 297bisect_next() {
8fe26f44 298 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 299 bisect_autostart
0a5280a9
JH
300 bisect_next_check good
301
97e1c51e 302 skip=$(git for-each-ref --format='%(objectname)' \
40a7ce64 303 "refs/bisect/skip-*" | tr '\012' ' ') || exit
97e1c51e
CC
304
305 BISECT_OPT=''
306 test -n "$skip" && BISECT_OPT='--bisect-all'
307
5be60078 308 bad=$(git rev-parse --verify refs/bisect/bad) &&
0a5280a9 309 good=$(git for-each-ref --format='^%(objectname)' \
40a7ce64 310 "refs/bisect/good-*" | tr '\012' ' ') &&
97e1c51e 311 eval="git rev-list --bisect-vars $BISECT_OPT $good $bad --" &&
0a5280a9 312 eval="$eval $(cat "$GIT_DIR/BISECT_NAMES")" &&
97e1c51e 313 eval=$(filter_skipped "$eval" "$skip") &&
0a5280a9
JH
314 eval "$eval" || exit
315
316 if [ -z "$bisect_rev" ]; then
317 echo "$bad was both good and bad"
318 exit 1
670f5fe3 319 fi
0a5280a9 320 if [ "$bisect_rev" = "$bad" ]; then
97e1c51e 321 exit_if_skipped_commits "$bisect_tried"
0a5280a9 322 echo "$bisect_rev is first bad commit"
5be60078 323 git diff-tree --pretty $bisect_rev
0a5280a9 324 exit 0
8cc6a083 325 fi
0a5280a9 326
97e1c51e
CC
327 # We should exit here only if the "bad"
328 # commit is also a "skip" commit (see above).
329 exit_if_skipped_commits "$bisect_rev"
330
0a5280a9 331 echo "Bisecting: $bisect_nr revisions left to test after this"
ee831f7d
GP
332 git branch -D new-bisect 2> /dev/null
333 git checkout -q -b new-bisect "$bisect_rev" || exit
0bee49c6 334 git branch -M new-bisect bisect
5be60078 335 git show-branch "$bisect_rev"
8cc6a083
LT
336}
337
cc9f24d0
JH
338bisect_visualize() {
339 bisect_next_check fail
235997c9
JH
340
341 if test $# = 0
342 then
508e84a7 343 case "${DISPLAY+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" in
235997c9 344 '') set git log ;;
508e84a7 345 set*) set gitk ;;
235997c9
JH
346 esac
347 else
348 case "$1" in
349 git*|tig) ;;
350 -*) set git log "$@" ;;
351 *) set git "$@" ;;
352 esac
353 fi
354
e3f062bf 355 not=$(git for-each-ref --format='%(refname)' "refs/bisect/good-*")
235997c9 356 eval '"$@"' refs/bisect/bad --not $not -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
357}
358
8cc6a083 359bisect_reset() {
fce0499f
CC
360 test -f "$GIT_DIR/BISECT_NAMES" || {
361 echo "We are not bisecting."
362 return
363 }
8cc6a083 364 case "$#" in
b577bb92
CW
365 0) if [ -s "$GIT_DIR/BISECT_START" ]; then
366 branch=`cat "$GIT_DIR/BISECT_START"`
810255fd
PB
367 else
368 branch=master
369 fi ;;
737c74ee
CC
370 1) git show-ref --verify --quiet -- "refs/heads/$1" ||
371 die "$1 does not seem to be a valid branch"
8cc6a083 372 branch="$1" ;;
8fe26f44 373 *)
8cc6a083
LT
374 usage ;;
375 esac
9b709e47 376 if git checkout "$branch"; then
b577bb92 377 # Cleanup head-name if it got left by an old version of git-bisect
38a47fd6 378 rm -f "$GIT_DIR/head-name"
b577bb92 379 rm -f "$GIT_DIR/BISECT_START"
38a47fd6 380 bisect_clean_state
9b709e47 381 fi
e204de28
JH
382}
383
38a47fd6 384bisect_clean_state() {
947a604b
CC
385 # There may be some refs packed during bisection.
386 git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* refs/heads/bisect |
387 while read ref hash
388 do
389 git update-ref -d $ref $hash
390 done
38a47fd6
CC
391 rm -f "$GIT_DIR/BISECT_LOG"
392 rm -f "$GIT_DIR/BISECT_NAMES"
393 rm -f "$GIT_DIR/BISECT_RUN"
394}
395
e204de28 396bisect_replay () {
737c74ee 397 test -r "$1" || die "cannot read $1 for replaying"
e204de28
JH
398 bisect_reset
399 while read bisect command rev
400 do
401 test "$bisect" = "git-bisect" || continue
402 case "$command" in
403 start)
e9a45d75 404 cmd="bisect_start $rev"
737c74ee
CC
405 eval "$cmd" ;;
406 good|bad|skip)
407 bisect_write "$command" "$rev" ;;
e204de28 408 *)
737c74ee 409 die "?? what are you talking about?" ;;
e204de28
JH
410 esac
411 done <"$1"
412 bisect_auto_next
8cc6a083
LT
413}
414
a17c4101 415bisect_run () {
83020120
CC
416 bisect_next_check fail
417
a17c4101
CC
418 while true
419 do
420 echo "running $@"
421 "$@"
422 res=$?
423
424 # Check for really bad run error.
425 if [ $res -lt 0 -o $res -ge 128 ]; then
426 echo >&2 "bisect run failed:"
427 echo >&2 "exit code $res from '$@' is < 0 or >= 128"
428 exit $res
429 fi
430
155fc795 431 # Find current state depending on run success or failure.
71b0251c
CC
432 # A special exit code of 125 means cannot test.
433 if [ $res -eq 125 ]; then
434 state='skip'
435 elif [ $res -gt 0 ]; then
155fc795 436 state='bad'
a17c4101 437 else
155fc795 438 state='good'
a17c4101
CC
439 fi
440
155fc795
CC
441 # We have to use a subshell because "bisect_state" can exit.
442 ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
a17c4101
CC
443 res=$?
444
445 cat "$GIT_DIR/BISECT_RUN"
446
71b0251c
CC
447 if grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
448 > /dev/null; then
449 echo >&2 "bisect run cannot continue any more"
450 exit $res
451 fi
452
a17c4101
CC
453 if [ $res -ne 0 ]; then
454 echo >&2 "bisect run failed:"
155fc795 455 echo >&2 "'bisect_state $state' exited with error code $res"
a17c4101
CC
456 exit $res
457 fi
458
459 if grep "is first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
460 echo "bisect run success"
461 exit 0;
462 fi
463
464 done
465}
466
467
8cc6a083
LT
468case "$#" in
4690)
470 usage ;;
471*)
472 cmd="$1"
473 shift
474 case "$cmd" in
475 start)
476 bisect_start "$@" ;;
155fc795
CC
477 bad|good|skip)
478 bisect_state "$cmd" "$@" ;;
8cc6a083
LT
479 next)
480 # Not sure we want "next" at the UI level anymore.
481 bisect_next "$@" ;;
235997c9 482 visualize|view)
cc9f24d0 483 bisect_visualize "$@" ;;
8cc6a083
LT
484 reset)
485 bisect_reset "$@" ;;
e204de28
JH
486 replay)
487 bisect_replay "$@" ;;
488 log)
489 cat "$GIT_DIR/BISECT_LOG" ;;
a17c4101
CC
490 run)
491 bisect_run "$@" ;;
8cc6a083
LT
492 *)
493 usage ;;
494 esac
495esac